#include <stdio.h>
#include <stdlib.h>
#include <string.h>
char radek[6 * 400 * 400];
int used[1000];
int delka[1000];
int start[1000];
int rstart[1000];
char matice[200][200];
char skrt[200][200];
char slovo[21];
char orez[21];
char orez1[21];
int r, s;
int vel;

struct tree
  {
    char text[21];
    struct tree *left, *right, *down;
  }
trees[10001 * 2 * 4];
int ntrees;

struct tree *root[3];

void
addtree (struct tree **root, char *text)
{
  int p = 0;
  struct tree *pos = *root;
  struct tree *lpos = *root;
  struct tree **ptr = NULL;
  /*printf("%s\n",text);*/
  while (pos != NULL)
    {
      lpos = pos;
  /*printf("%s %s\n",pos->text,text);*/
      if (text[p] < pos->text[p])
	ptr = &pos->left;
      else if (text[p] > pos->text[p])
	ptr = &pos->right;
      else
	{
	  ptr = &pos->down;
	  p++;
	  if (!text[p])
	    break;
	}
      pos = *ptr;
    }
  if (lpos && !strcmp (text, lpos->text))
    return;
  strcpy (trees[ntrees].text, text);
  trees[ntrees].left = NULL;
  trees[ntrees].right = NULL;
  trees[ntrees].down = NULL;
  if (ptr)
    *ptr = trees + ntrees;
  else
    *root = trees + ntrees;
  ntrees++;
}
int
findtree (struct tree *root, char *text)
{
  int p = 0;
  int l=0;
  struct tree *pos = root;
  struct tree *lpos = root;
#if 0
  printf("tesxt\n");
  printf("%s\n",text);
#endif
  if (!root) return 0;
  while (pos != NULL)
    {
      lpos = pos;
      if (text[p] < pos->text[p])
	pos = pos->left;
      else if (text[p] > pos->text[p])
	pos = pos->right;
      else
	{
	  p++;
	  if (!text[p])
	    if (!strncmp (pos->text, text, strlen (pos->text))) l=p;
	  pos = pos->down;
	}
    }
  /*printf("ok %s %s %i %i\n",lpos->text, text,p,l);*/
  if (!strncmp (lpos->text, text, strlen (lpos->text)))
    return strlen(lpos->text);
  else return l;
}
int
orezej (int delka)
{
  int d = strlen (slovo);
  int p = delka;
  while (p < d)
    {
      if (slovo[p] != slovo[p % delka])
	return 0;
      p++;
    }
  if (d > delka)
    d = delka;
  for (p = 0; p < delka; p++)
    orez[p] = slovo[p], orez1[p] = slovo[d - p - 1];
  orez[p] = 0;
  return 1;
}
void
skrtni (int start, struct tree *root, int delka, int *rstart, int xs, int ys, int xp, int yp)
{
  char *f;
  int pos = *rstart;
  int pos1;
  int x, y;
  int delka2;

#if 0
  while (skrt[(pos * xs + x) % r][(pos * ys + y) % s] && pos < delka)
    pos++;
#endif

/*printf("slovo:%s\n",text); */
  *rstart = pos;
  while (pos < delka)
    {
#if 0
      while (skrt[(pos * xp + xs) % r][(pos * yp + ys) % s] && pos < delka)
	pos++;
      pos -= delka2;
#endif
      if (pos < 0)
	pos = 0;
      delka2 = findtree (root, radek + pos + start);
      if (!delka2)
	{
	  pos++;
	  continue;
	}
/*printf("%i %i %i %s\n",xs,ys,pos,radek+start);
   printf("%s\n",f); */
#if 0
      pos = f - radek - start;
#endif
      pos1 = 0;
      while (pos1 < delka2)
	{
	  skrt[((pos + pos1) * xp + xs) % r][((pos + pos1) * yp + ys) % s] = 1;
	  pos1++;
	}
#if 0
      pos += pos1 + 1;
#endif
      pos++;
#if 0
      for (y = 0; y < s; y++)
	{
	  for (x = 0; x < r; x++)
	    printf ("%i ", skrt[x][y]);
	  printf ("\n");
	}
#endif
    }
}
int
main ()
{
  int x, y;
  int z;
  int pos;
  int sikdelka = 0;
  scanf ("%i\n", &z);
  while (z)
    {
      scanf ("%i %i\n", &s, &r);
      pos = 0;
      memset (skrt, 0, sizeof (skrt));
      ntrees = 0;
      for (y = 0; y < s; y++)
	{
	  for (x = 0; x < r; x++)
	    matice[x][y] = getc (stdin);
	  getc (stdin);
	}
      for (y = 0; y < s; y++)
	{
	  start[y] = pos;
	  for (x = 0; x < r * 2; x++)
	    radek[pos] = matice[x % r][y], pos++;
	  radek[pos] = 0;
	  pos++;
	  delka[y] = x;
	  rstart[y] = 0;
	}
      for (x = 0; x < r; x++)
	{
	  start[x + 200] = pos;
	  for (y = 0; y < s * 2; y++)
	    radek[pos] = matice[x][y % s], pos++;
	  radek[pos] = 0;
	  pos++;
	  delka[x + 200] = y;
	  rstart[x + 200] = 0;
	}
      for (x = 0; x < r; x++)
	used[x] = 0;
      for (x = 0; x < r; x++)
	{
	  int p;
	  if (!used[x])
	    {
	      p = 0;
	      start[x + 400] = pos;
	      while (1)
		{
		  int rx = (x + p) % r;
		  int ry = (p) % s;
		  if (!ry)
		    used[rx]++;
		  if (used[rx] == 2)
		    break;
		  radek[pos++] = matice[rx][ry];
		  p++;
		}
	      radek[pos++] = 0;
	      rstart[x + 400] = 0;
	      delka[x + 400] = pos;
	    }
	  else
	    start[x + 400] = -1;

	}
#if 1
      for (x = 0; x < r; x++)
	used[x] = 0;
      for (x = 0; x < r; x++)
	{
	  int p;
	  if (!used[x])
	    {
	      p = 0;
	      start[x + 800] = pos;
	      while (1)
		{
		  int rx = (r * r * r + x - p) % r;
		  int ry = (p) % s;
		  if (!ry)
		    used[rx]++;
		  if (used[rx] == 2)
		    break;
		  radek[pos++] = matice[rx][ry];
		  p++;
		}
	      radek[pos++] = 0;
	      sikdelka = strlen (radek + start[800]);
	      delka[x + 800] = pos;
	      rstart[x + 800] = 0;
	    }
	  else
	    start[x + 800] = -1, rstart[x + 800] = 0;

	}
#endif
      scanf ("%i\n", &y);
      while (y)
	{
	  gets (slovo);
	  if (orezej (r))
	    {
	      addtree (root + 0, orez);
	      addtree (root + 0, orez1);
	    }
	  if (orezej (s))
	    {
	      addtree (root + 1, orez);
	      addtree (root + 1, orez1);
	    }
	  if (orezej (sikdelka))
	    {
	      addtree (root + sikdelka, orez);
	      addtree (root + sikdelka, orez1);
	    }
	  y--;
	}
      for (x = 0; x < s; x++)
	{
	  skrtni (start[x], root[0], delka[x], rstart + x, 0, x, 1, 0);
	}
      for (x = 0; x < r; x++)
	{
	  skrtni (start[x + 200], root[1], delka[x + 200], rstart + x + 200, x, 0, 0, 1);
	}
      for (x = 0; x < r; x++)
	{
	  if (start[x + 400] >= 0)
	    {
	      skrtni (start[x + 400], root[2], delka[x + 400], rstart + x + 400, x, 0, 1, 1);
	    }
	}
      for (x = 0; x < r; x++)
	{
	  if (start[x + 800] >= 0)
	    {
	      skrtni (start[x + 800], root[2], delka[x + 800], rstart + x + 800, x + r * r * r, 0, -1, 1);
	    }
	}
      for (y = 0; y < s; y++)
	for (x = 0; x < r; x++)
	  if (!skrt[x][y])
	    putc (matice[x][y], stdout);
      putc ('\n', stdout);
      z--;
    }
  return 0;
}
